version: '3'
volumes:
  mongo-data:
  mongo-backup:
services:
  mongo:
    container_name: tezos-digisign-mongo
    image: mongo:5.0.7
    ports:
      - '27017:27017'
    volumes:
      - 'mongo-data:/data/db'
    environment:
      MONGO_INITDB_ROOT_USERNAME: root
      MONGO_INITDB_ROOT_PASSWORD: password
      MONGO_INITDB_DATABASE: tezos-signature
    restart: unless-stopped
  mongo-backup:
    container_name: tezos-digisign-mongo-backup
    image: istepanov/mongodump:4.2
    environment:
      MONGO_URI: 'mongodb://root:password@mongo:27017'
      CRON_SCHEDULE: '0 0 * * *'
    volumes:
      - mongo-backup:/backup
    restart: unless-stopped
    depends_on:
      - mongo
  mongo-express:
    container_name: tezos-digisign-mongo-express
    image: mongo-express:0.54.0
    ports:
      - '8081:8081'
    environment:
      ME_CONFIG_MONGODB_SERVER: mongo
      ME_CONFIG_MONGODB_ADMINUSERNAME: root
      ME_CONFIG_MONGODB_ADMINPASSWORD: password
    restart: unless-stopped
    depends_on:
      - mongo
  mail:
    container_name: tezos-digisign-mail
    image: gessnerfl/fake-smtp-server:1.3.0
    ports:
      - "5025:5025"
      - "5080:5080"
      - "5081:5081"
    environment:
      FAKESMTP_AUTHENTICATION_USERNAME: username
      FAKESMTP_AUTHENTICATION_PASSWORD: password
    restart: unless-stopped
  rest:
    container_name: tezos-digisign-rest
    image: coexyaedi/tezos-digisign-rest:local
    build: frontend/rest
    environment:
      SECURITY_ALLOWEDORIGIN: "http://localhost:8080"
      SECURITY_OPENCORS: "true"
    volumes:
      - "./compose-config/testnet/application-rest.yml:/app/application.yml:ro"
    restart: unless-stopped
    depends_on:
      - mongo
      - daemon
  daemon:
    container_name: tezos-digisign-daemon
    image: coexyaedi/tezos-digisign-daemon:local
    build: backend/daemon
    volumes:
      - "./compose-config/testnet/application-daemon.yml:/app/application.yml:ro"
    restart: unless-stopped
    depends_on:
      - mongo
      - mail
  ui:
    container_name: tezos-digisign-ui
    image: coexyaedi/tezos-digisign-ui:local
    build: frontend/jsclient
    environment:
      REST_URL: /api
      UNSECURED_TOKEN: 1
    restart: unless-stopped
    depends_on:
      - rest
  proxy:
    image: nginx:1.21.6-alpine
    container_name: tezos-digisign-rp
    volumes:
      - "./reverseProxy/reverseproxy.conf:/etc/nginx/conf.d/default.conf"
      - "./reverseProxy/certs/digisign.com.crt:/etc/nginx/certs/digisign.com.crt"
      - "./reverseProxy/certs/digisign.com.key:/etc/nginx/certs/digisign.com.key"
    ports:
      - "8080:80"
    restart: unless-stopped
